VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Tabelle1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit

Sub ZeilenEinfuegen()
   ' Hinweis: Die 1. Zeile wird stets OBERHALB der Variablen FirstDataRow eingefgt
   Dim AnzRowsSel As Long, RowsInWks As Long, MaxRows As Long
   Dim LastDataRow As Long, FirstDataRow As Long, FreeRows As Long
   Dim i As Long, z As Long, AnzEinZe As Integer, CalcStatus As Variant
   
   With ActiveSheet
      RowsInWks = .Rows.Count     'Maximale/alle Zeilen des WorkSheets
      LastDataRow = .Cells(RowsInWks, "A").End(xlUp).Row  'Letzte Datenzeile
   End With
   FirstDataRow = 2  'Siehe Hinweis oben, bei Bedarf apassen
   AnzEinZe = 1      'Anzahl der einzufgenden Zeilen
   FreeRows = RowsInWks - LastDataRow   'Noch freie Zeilen
   MaxRows = FreeRows / (AnzEinZe + 1)   'Die Hlfte davon
   AnzRowsSel = LastDataRow   'Hierber wird die erste Leerzeile eingefgt, bei Bedarf ndern
   
   On Error GoTo ErrorHandler
   With Application
      .ScreenUpdating = False  'Wegen Schnelligkeit und Flimmern
      CalcStatus = .Calculation
      .Calculation = xlCalculationManual
   End With
   If MaxRows >= AnzRowsSel Then
      For i = LastDataRow To FirstDataRow Step -1
         Rows(i).EntireRow.Resize(AnzEinZe).Insert
      Next i
   Else  'Es wren zu viele Zeilen
      MsgBox "Zu viele Datenzeilen," & vbCrLf _
      & "ein Einfgen von Leerzeilen ist nicht mglich.", _
      vbCritical + vbOKOnly, "Fehler!"
   End If
   
ErrorHandler:
   With Application
      .Calculation = CalcStatus
      .ScreenUpdating = True
   End With
   If Err.Number <> 0 Then MsgBox "Fehler Nr.: " & Err.Number & vbCrLf & Err.Description
End Sub

